<!DOCTYPE html>
<html>

<head>
    <meta charset="UTF-8">
    <title>Stencil-o-Matic</title>

    <link type="text/css" href="assets/css/stencil-o-matic.css" rel="stylesheet" />
    <link type="text/css" href="assets/css/smoothness/jquery-ui-1.10.4.custom.css" rel="stylesheet" />

    <script src="ext/jquery.min.js"></script>
    <script src="ext/jquery-ui.min.js"></script>
    <script type="text/javascript" src="js/easeljs-0.7.1.min.js"></script>
    <script type="text/javascript" src="js/potrace_outscad.js"></script>

    <script type="text/javascript">
        var MAX_WIDTH = 512;
        var MAX_HEIGHT = 384;
        var img;
        var stage;
        var bmp;
        var DELTA_INDEX;
        var blurSlider, thresholdSlider;
        var blurFilter;
        var greyFilter;
        var slideInterval = -1;
        var scaleImg = 1;

        function init() {
            if (window.top != window) {
                document.getElementById("header").style.display = "none";
            }
            document.getElementById("loader").className = "loader";

            img = new Image();
            img.onload = handleImageLoad;
            img.src = "assets/void.png";

            document.getElementById("file").onchange = function(e) {
                $("#svg").empty();
                document.getElementById("selectOutput").style.display = "none";
                document.getElementById("outputText").style.display = "none";
                document.getElementById("settingsTable").style.display = "none";
                document.getElementById("outputSettings").style.display = "none";
                document.getElementById("invertcb").checked = false;
                document.getElementById("islandscb").checked = true;

                /*document.getElementById("timer").style.display = "none";*/

                var files = e.target.files;
                if (files.length == 0) {
                    return;
                }
                var file = files[0];

                if (!file.type.match(/image\/.+/)) {
                    return;
                }

                if (file.type == "image/svg+xml") {
                    return;
                }
                var reader = new FileReader();
                reader.onload = function() {
                    displayImage(reader.result);
                };
                reader.readAsDataURL(file);

                document.getElementById("settingsTable").style.display = "block";
                document.getElementById("outputSettings").style.display = "inline";
            };

            $('#invertcb').change(function() {
                invertImg();
            });

            $('#islandscb').change(function() {
                traceImage();
            });

        } // init

        function handleImageLoad() {
            document.getElementById("loader").className = "";


            var canvas = document.getElementById("imgCanvas");
            var iRatio = img.width / img.height;

            if (iRatio >= MAX_WIDTH / MAX_HEIGHT) {
                canvas.width = Math.min(MAX_WIDTH, img.width);
                canvas.height = canvas.width / iRatio;
                scaleImg = Math.min(1, canvas.width / img.width);
            } else {
                canvas.height = Math.min(MAX_HEIGHT, img.height);
                canvas.width = canvas.height * iRatio;
                scaleImg = Math.min(1, canvas.height / img.height);
            }

            stage = new createjs.Stage(canvas);

            bmp = new createjs.Bitmap(img);
            bmp.scaleX = bmp.scaleY = scaleImg;
            bmp.cache(0, 0, img.width, img.height);
            stage.addChild(bmp);

            $(".blurSlider").slider({
                value: 1,
                min: 0,
                max: 12,
                disabled: false,
                change: handleChange,
                slide: handleSlide
            });

            $(".thresholdSlider").slider({
                value: 40,
                min: 0,
                max: 100,
                disabled: false,
                change: handleChange,
            });

            $("#selectBtn").click(selectOutput);
            $("input[name='outputversion']").change(function() {
                traceImage();
            });
            $("#outputversion").change(function() {
                traceImage();
            });
            applyEffect();
        }

        function invertImg() {
            var c = document.getElementById("imgSrc");
            var ctx = c.getContext("2d");
            var imgData = ctx.getImageData(0, 0, img.width, img.height);
            for (var i = 0; i < imgData.data.length; i += 4) {
                imgData.data[i] = 255 - imgData.data[i];
                imgData.data[i + 1] = 255 - imgData.data[i + 1];
                imgData.data[i + 2] = 255 - imgData.data[i + 2];
                imgData.data[i + 3] = 255;
            }
            ctx.putImageData(imgData, 0, 0);

            stage.removeChild(bmp);
            bmp = new createjs.Bitmap(c);
            bmp.scaleX = bmp.scaleY = scaleImg;
            bmp.cache(0, 0, img.width, img.height);
            stage.addChild(bmp);
            updateImage();
            traceImage();
        }

        function selectOutput() {
            $("#outputText").focus();
            $("#outputText").select();
        }

        function handleSlide() {
            if (slideInterval == -1) {
                slideInterval = setInterval(applyEffect, 250);
            }
        }

        function handleChange() {
            clearInterval(slideInterval);
            slideInterval = -1;
            applyEffect();
            traceImage();
        }

        function applyEffect() {
            var blurValue = $(".blurSlider").slider("option", "value");
            blurFilter = new createjs.BlurFilter(blurValue, blurValue, 2);

            var greyscale = new createjs.ColorMatrix().adjustSaturation(-100);
            greyFilter = new createjs.ColorMatrixFilter(greyscale);

            updateImage();
        }

        function updateImage() {
            bmp.filters = [blurFilter, greyFilter];
            bmp.updateCache();
            stage.update();
        }

        function displayImage(data) {
            img.src = data;
            var cSrc = document.getElementById('imgSrc');
            var imgS = new Image();
            imgS.src = data;
            imgS.onload = function() {
                cSrc.width = this.width;
                cSrc.height = this.height;
                cSrc.getContext('2d').drawImage(this, 0, 0);
            }
        }

        function traceImage() {
            $("#svg").empty();

            /*var timer = document.getElementById("timer")
            timer.innerHTML = "";*/
            var divText = document.getElementById("outputText");
            divText.innerHTML = "";

            var start = new Date();

            var potimg = document.getElementById("imgCanvas");
            var potwidth = potimg.width;
            var potheight = potimg.height;

            var svg = document.getElementById("svg");
            svg.setAttribute("width", potwidth);
            svg.setAttribute("height", potheight);
            svg.setAttribute("viewBox", [0, 0, potwidth, potheight].join(" "));

            var thresholdValue = $(".thresholdSlider").slider("option", "value") / 100;

            Potrace.setParam({
                threshold: thresholdValue,
                turdSize: 3,
                turnPolicy: 1,
                alphamax: 0.9,
                precision: 2
            });

            /*var outputVersion = $("input:radio[name=outputversion]:checked").val();*/
            var outputVersion = "stencil";
            outputVersion = $("#outputversion").val();
            var showIslands = $("#islandscb").attr('checked');

            var gElem = Potrace.trace(potimg, outputVersion, showIslands).toPathElements();
            svg.appendChild(gElem);

            var gText = Potrace.outputScad();
            divText.innerHTML = gText;

            document.getElementById("selectOutput").style.display = "block";
            document.getElementById("outputText").style.display = "block";
            document.getElementById("outputText").style.display = "none";
            document.getElementById("link").style.display = "inline";
            /*
	        var end = new Date();
			timer.innerHTML =  (end.getTime() - start.getTime()) + " ms";
	        document.getElementById("timer").style.display = "block";*/

            //get svg element.
            var svg = document.getElementById("svg");

            //get svg source.
            var serializer = new XMLSerializer();
            var source = serializer.serializeToString(svg);

            //add name spaces.
            if (!source.match(/^<svg[^>]+xmlns="http\:\/\/www\.w3\.org\/2000\/svg"/)) {
                source = source.replace(/^<svg/, '<svg xmlns="http://www.w3.org/2000/svg"');
            }
            if (!source.match(/^<svg[^>]+"http\:\/\/www\.w3\.org\/1999\/xlink"/)) {
                source = source.replace(/^<svg/, '<svg xmlns:xlink="http://www.w3.org/1999/xlink"');
            }

            //add xml declaration
            source = '<?xml version="1.0" standalone="no"?>\r\n' + source;

            //convert svg source to URI data scheme.
            var url = "data:image/svg+xml;charset=utf-8," + encodeURIComponent(source);

            //set url value to a element's href attribute.
            document.getElementById("link").href = url;
            //you can download svg file by right click menu.


        }
    </script>

    <style type="text/css">
        .blurSlider {
            width: 120px;
        }
        
        .thresholdSlider {
            width: 200px;
        }
        
        body {
            margin: 4px;
        }
        
        svg {
            width: 512px;
            height: 384px;
        }
        
        g>path.even {
            fill: #FFCBCB;
            fill: #FFFFFF;
        }
        
        g>path.odd {
            fill: #454560;
            fill: #000000;
        }
        
        #tools {
            top: 5px;
            left: 5px;
            width: 100%;
            height: 50px;
            background: #FFFFFF;
        }
    </style>
</head>

<body onload="init()">
    <h1> Stencil-o-Matic</h1>
    <small>inspirée de <a href="http://www.chaaawa.com/a-propos/">Benjamin "CHAAAWA"</a></small>
    <br>
    <br>
    <canvas id="imgSrc" style="display:none"></canvas>

    <div id="loader"></div>
    <div id="tools">
        <input id="file" type="file"></input>

        <div style="display:none" id="outputSettings">
            <label for="outputversion">Sortie</label>
            <select id="outputversion" name="outputversion">
                <option value="stencil" selected>Pochoir</option>
                <option value="stamp">Tampon</option>
                <option value="cookie">Cookie</option>
            </select>
            <input type="checkbox" id="invertcb" name="invert"></input>
            <label for="invertcb">Inverser l'image</label>
            <span><img src="assets/void.png" width="60" height="10" /></span>

            <!-- 
		<input type="radio" value="stencil" id="stencil" name="outputversion" checked="checked">
		<label for="stencil">stencil</label>
		<input type="radio" value="stamp" id="stamp" name="outputversion">
		<label for="stamp">stamp</label>
		<input type="radio" value="cookie" id="cookie" name="outputversion">
		<label for="cookie">cookie cutter</label> -->

            <input type="checkbox" id="islandscb" name="showisland" checked=""></input>
            <label for="islandscb">Montrer les ilôts</label>
            <!-- <span><small>(les zones roses ne seront pas visibles)</small></span> -->

        </div>

        <table id="settingsTable" style="display:none">
            <td>
                <table cellspacing="2" border="0" cellpadding="2">
                    <tr>
                        <th rowspan="1" align="center">Blur</th>
                        <td>
                            <div class="blurSlider"></div>
                        </td>
                        <th rowspan="1" align="center">Threshold</th>
                        <td>
                            <div class="thresholdSlider"></div>
                        </td>
                    </tr>
                </table>
            </td>
        </table>
    </div>

    <div>
        <canvas id="imgCanvas" width="320" height="200"></canvas>
        <svg id="svg"></svg>
    </div>


    <div id="selectOutput" style="display:none"></div>
    <table id="selectOutputEx" style="display:none">
        <tr>
            <td><input id="selectBtn" type="button" value="Select text"></input>
            </td>
            <td>"Select text", copy, then paste it in <a href="http://www.thingiverse.com/thing:55821">Customizer</a></td>
        </tr>
    </table>

    <textarea id="outputText" width="120" style="display:none"></textarea>

    <br>
    <a id="link" href="#" style="display:none">Click droit -> Enregistrer la cible du lien sous</a>
    <!-- <div id="timer" style="font-size:10px"></div> -->
    <!-- <textarea id="debug" style="width:500px;height:250px">debug</textarea> -->
    <!-- 
<hr/>
<h1> Flash version </h1>
 <object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=9,0,0,0" id="xylobot" align="middle" height="100%" width="100%">
      <param name="allowScriptAccess" value="sameDomain">
      <param name="movie" value="assets/stencil_factory.swf">
      <param name="menu" value="false">
      <param name="quality" value="high">
      <param name="scale" value="noScale">
      <param name="salign" value="TL">
      <param name="bgcolor" value="#333333">
      <embed src="assets/stencil_factory.swf" menu="false" quality="high" scale="noScale" salign="TL" bgcolor="#FFFFFF" name="xylobot" allowscriptaccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" align="middle" height="100%" width="100%">
    </object> -->
</body>

</html>